#!/usr/bin/env python3
""" 
  Course:      Data Structures and Algorithms for CL III - WS2324
  Assignment:  (Assignment number)
  Author:      (Your name)
  Description: (...)
  Honor Code:  I pledge that this program represents my own work.
"""

def cyclic_hash(word, shift=5, size=32, start=0x877218c4430b9321):
    """
    Calculate a hash code for a given word with cyclic-shift.
    
    Args:
        s (str): word to be hashed
        shift (int, optional): amount of shift.
        size (int, optional): size of the returned hash in bits.
        start (hexadecimal, optional): Initial constant for hashing (helps producing independent
                                       hash functions with the same amount of shift).
    
    Returns:
        int: the hash code for the given word.
    """
    # TODO Exercise 1
    pass

    
class BloomFilter:
    def __init__(self, size=50, k=3):  # TODO Exercise 2.4
        """
        Initialize Bloom Filter with all `False`.

        Args:
            size (int, optional): The size of the filter. Note that the size (in bits) should
                                  not be larger than the space needed storing a set of hash
                                  codes for the words in our lexicon.txt.
            k (int, optional): Number of hash functions.
        """
        self.bfilter = [False] * size
        
    def _hash(self, word):
        """
        Use the `cyclic_hash()` function and its parmetre `shift` or `start`
        (or both) to get `k` variations of this hash function. Then use these
        functions to return the `k` different hash codes for this word.

        Args:
            word (str): word to be hashed.

        Returns:
            list[int]: list of `k` hash codes.
        """
        # TODO Exercise 2.1
        pass
    
    def contains(self, word):
        """
        Check whether the Bloom filter contains a word or not. False positives
        might happen.

        Args:
            word (str): word to be checked.

        Returns:
            bool: `True` if the word is in the filter.
        """
        # TODO Exercise 2.2
        pass

    def add(self, word):
        """
        Add a word to the Bloom filter.

        Args:
            word (str): word to be added.

        Returns:
            bool: `True` if the word was already in the filter.
        """
        # TODO Exercise 2.3
        pass


if __name__ == "__main__":
    
    # Example use: efficiently remove word duplicates
    
    # tokens = with duplicates
    word_tokens = open('lexicon.txt', 'rt')\
                    .read()\
                    .strip()\
                    .split()
                    
    # types = without duplicates
    word_types = []
    bf = BloomFilter()
    for w in sorted(word_tokens):
        if not bf.add(w):
            word_types.append(w)
    
    print("Word tokens:", len(word_tokens))
    print("Word types:", len(word_types))
